﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace xamChart2
{
    public class PatientBusinessLogic
    {
        public ObservableCollection<Patient> GetPatients()
        {
            ObservableCollection<Patient> patients = new ObservableCollection<Patient>();

            Patient p = new Patient("David", 160, 70, 105, 70);
            patients.Add(p);
            p = new Patient("George", 145, 66, 111, 77);
            patients.Add(p);
            p = new Patient("John", 190, 71, 90, 60);
            patients.Add(p);

            return patients;
        }
    }

    public class Patient : INotifyPropertyChanged
    {
        private string patient_name;
        public string Name
        {
            get { return patient_name; }
            set
            {
                if (patient_name != value)
                {
                    patient_name = value;
                    NotifyPropertyChanged("Name");
                }
            }
        }

        private int patient_height;
        public int Height
        {
            get { return patient_height; }
            set
            {
                if (patient_height != value)
                {
                    patient_height = value;
                    NotifyPropertyChanged("Height");
                }
            }
        }

        private int patient_weight;
        public int Weight
        {
            get { return patient_weight; }
            set
            {
                if (patient_weight != value)
                {
                    patient_weight = value;
                    NotifyPropertyChanged("Weight");
                }
            }
        }

        private int patient_systolic_pressure;
        public int SystolicPressure
        {
            get { return patient_systolic_pressure; }
            set
            {
                if (patient_systolic_pressure != value)
                {
                    patient_systolic_pressure = value;
                    NotifyPropertyChanged("SystolicPressure");
                }
            }
        }

        private int patient_diastolic_pressure;
        public int DiastolicPressure
        {
            get { return patient_diastolic_pressure; }
            set
            {
                if (patient_diastolic_pressure != value)
                {
                    patient_diastolic_pressure = value;
                    NotifyPropertyChanged("DiastolicPressure");
                }
            }
        }

        public Patient(string name, int weight, int height, int systolicPressure, int diastolicPressure)
        {
            this.Name = name;
            this.Weight = weight;
            this.Height = height;
            this.SystolicPressure = systolicPressure;
            this.DiastolicPressure = diastolicPressure;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
